;EXAMINE DPB'S FOR A:-D: AND PATCH CPM3.SYS
;**** V1.0
;ASSUME 512 BYTE SECTORS

DPHTAB	= 0FBB3H
DPBA	= BUFF+80H
DPBB	= BUFF+0A5H
DPBC	= BUFF+0CAH
DPBD	= BUFF+0EFH

	LD DE,INTRO
	LD C,9
	CALL 5

	LD C,12			;IF THERE RUNNING 3.1
	CALL 5			; THEN ABORT
	LD A,31H
	CP L
	JR NZ,OS_OK

	LD DE,OS_ERROR
	LD C,9
	CALL 5
	JP 0

OS_OK:	CALL READ
LOOP22:	LD DE,ADJMES
	LD C,9
	CALL 5
	LD C,1
	CALL 5
	CP 'Y'
	JR Z,YES
	CP 'y'
	JR Z,YES
	CP 'N'
	JR Z,NO
	CP 'n'
	JR Z,NO
	JR LOOP22

YES:	LD A,0FFH
	LD (ADJFL),A
	JR SKIP

NO:	XOR A
	LD (ADJFL),A

SKIP:	LD IX,(DPHTAB)

	LD H,(IX+11)
	LD L,(IX+10)
	LD DE,DPBA
	CALL ADJUST

	LD H,(IX+27)
	LD L,(IX+26)
	LD DE,DPBB
	CALL ADJUST

	LD H,(IX+43)
	LD L,(IX+42)
	LD DE,DPBC
	CALL ADJUST

	LD H,(IX+59)
	LD L,(IX+58)
	LD DE,DPBD
	CALL ADJUST

	CALL WRITE

	LD DE,ALL_OK
	LD C,9
	CALL 5
	JP 0

ADJUST:	LD A,L
	OR H
	JR Z,NO_DRV			;IF DPB ADDR IS 0 THEN NO DRIVE

	PUSH DE
	LD BC,15			;COPY DPB TO BUFFER
	LDIR

	POP IY

	LD A,(ADJFL)
	OR A
	JR Z,NO_ADJ

	LD A,(IY+2)			;IF NOT 2K BLOCKS SKIP ADJUST
	CP 4
	JR NZ,NO_ADJ

	LD A,(IY+6)			;IF TOP BYTE OF DRM IS 0 SKIP ADJUST
	OR A
	JR NZ,NO_ADJ

	LD (IY+5),A			;SET DRM = 256 I.E. 257 BLOCKS
	LD A,1
	LD (IY+6),A

	PUSH IX				;INDICATE ADJUSTMENT
	LD C,2
	LD E,'+'
	CALL 5
	POP IX
	RET

NO_ADJ:	PUSH IX				;INDICATE NO ADJUSTMENT
	LD C,2
	LD E,'-'
	CALL 5
	POP IX
	RET

NO_DRV:	PUSH IX				;INDICATE NO DRIVE
	LD C,2
	LD E,'/'
	CALL 5
	POP IX
	RET

READ:	LD DE,FCB
	LD C,15
	CALL 5
	CP 255
	JR Z,IO_ERR

	LD C,26			;READ RECORDS 2,3 TO BUF
	LD DE,BUFF
	CALL 5

	LD A,2
	LD (REC),A
	LD DE,FCB
	LD C,33
	CALL 5
	OR A
	JR NZ,IO_ERR

	LD C,26
	LD DE,BUFF+128
	CALL 5

	LD A,3
	LD (REC),A
	LD DE,FCB
	LD C,33
	CALL 5
	OR A
	JR NZ,IO_ERR
	RET

WRITE:	LD C,26			;WRITE BUFF TO RECORDS 2,3
	LD DE,BUFF
	CALL 5

	LD A,2
	LD (REC),A
	LD DE,FCB
	LD C,34
	CALL 5
	OR A
	JR NZ,IO_ERR

	LD C,26
	LD DE,BUFF+128
	CALL 5

	LD A,3
	LD (REC),A
	LD DE,FCB
	LD C,34
	CALL 5
	OR A
	JR NZ,IO_ERR

	LD DE,FCB
	LD C,16
	CALL 5
	CP 255
	JR Z,IO_ERR
	RET

IO_ERR:	LD DE,FCB
	LD C,16
	CALL 5
	LD DE,IO_MESS
	LD C,9
	CALL 5
	JP 0

INTRO:	DB 'EINSTEIN CPM+ AUTO CONFIGURE UTILITY',0DH,0AH
	DB 'SCANNING CURRENT SETUP',0DH,0AH,'$'

ADJMES:	DB 'ADJUST DISK PARAMETERS (Y/N):',0DH,0AH,'$'
ADJFL:	DB 0

ALL_OK:	DB 0DH,0AH,'CPM+ CONFIGURATION COMPLETE',0DH,0AH,'$'

OS_ERROR: DB 'PROGRAM WILL NOT RUN UNDER CPM+',0DH,0AH,'$'

FCB:	DB 0,'CPM3    SYS',0,0,0,0
	DS 17
REC:	DB 0
	DB 0,0

IO_MESS: DB 'ERROR READ OR WRITING DISC',0DH,0AH,'$'

BUFF:	DS 255
B 0,'CPM3    SYS',0,0,0,0
	DS 17
REC:	DB 0
	DB 0,0

IO_MESS: DB 'ERROR READ OR WRITING DISC',0DH,0AH,'$'
