	TITLE	'system initialisation module for CP/M 3'

; initialisation routines
;
; Hardware init not needed as CPMLDR.COM run from Xtal Dos
; does it all for us.
; Duncan Elvin 30-Dec-93     version 3.0

; 
; Miscellaneous initialisation on cold boot and cold and warm boot
; loading of CCP.

	NAME	'BOOT'

	MACLIB	Z80

	PUBLIC	?INIT,?LDCCP,?RLCCP

	EXTRN	?PMSG,?CONIN,?BNKSL,?MOV,?XMOV
	EXTRN	@CIVEC,@COVEC,@AIVEC,@AOVEC,@LOVEC

;
BDOS	EQU	0005H			; BDOS entry point address

; Usefull ASCII characters
CR	EQU	13
LF	EQU	10
BEL	EQU	7


; Initialise


?INIT:  LXI     H,1000H                 ; assign conout to VDP         
	SHLD	@COVEC
        LXI     H,2000H                 ; assign conin to KBD
	SHLD	@CIVEC
	LXI	H,4000H			; assign printer to LPT
	SHLD	@LOVEC
        LXI     H,8000H
	SHLD	@AIVEC			; assign AUX to SIO
	SHLD	@AOVEC
	LXI	H,SIGNON		; print greetings
	CALL	?PMSG
	RET

SIGNON:	DB	CR,LF,'Einstein CP/M 3 BIOS D3.1'
	DB	CR,LF,0

; Load the command processor.
; First the default disk is searched, then disk A:, and then the user
; is prompted to replace the system disk in A:.

?RLCCP:
?LDCCP:	MVI	C,45
	MVI	E,0FFH
	CALL	BDOS			; needed if no disk in A:
	XRA	A
	LXI	D,FCB
	STAX	D			; try default drive first
LDCCP0:	STA	FCBEX			; extent=0
	STA	FCBCR			; start at beginning of file
	MVI	C,15			; open file
	CALL	BDOS
	INR	A			; check that file was found
	JRNZ	LDCCP1
	LXI	H,FCB			; has disk A: been searched?
	CMP	M
	JRNZ	NOCCP
	INR	M			; now try A:
	XCHG
	JR	LDCCP0
LDCCP1:	LXI	D,0100H			; load CCP into TPA
	MVI	C,26
	CALL	BDOS
	LXI	D,128			; allow upto 128 records!
	MVI	C,44
	CALL	BDOS
	LXI	D,FCB			; read the file
	MVI	C,20
	CALL	BDOS
	RET

; file not found
NOCCP:	LXI	H,ERRMSG		; print error message
	CALL	?PMSG
	CALL	?CONIN			; wait for response
	MVI	C,13			; reset disk system
	CALL	BDOS
	JR	?LDCCP			; and try again


;
ERRMSG:	DB	CR,LF,BEL,'File CCP.COM not found'
	DB	CR,LF,'Insert system disk into A: then hit a key',0
;
FCB:	DB	0,'CCP     ','COM'
FCBEX:	DB	0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
FCBCR:	DB	0
	DB	0,0,0

	END
key',0
;
FCB:	DB	