; CP/M v3.1  loader program for the Einstein
bdos    =       5
                aorg    0100h
                ld      sp,buff+256                     
                call    sys_init                       
                ld      c,0dh                                 
                call    bdos                                  
                ld      c,9                                   
                ld      de,signon                             
                call    bdos                                  
                ld      c,0fh                                 
                ld      de,fcb                                
                call    bdos                                  
                cp      0ffh                                  
                ld      de,no_ccp                      
                jp      z,abort                        
                ld      de,080h                               
                call    set_DMA                       
                call    read_sect                      
                ld      hl,080h                               
                ld      de,buff                         
                ld      bc,6                             
                ldir                                                           
                call    read_sect                                  
                ld      c,9                                   
                ld      de,080h                               
                call    bdos                                  
                ld      a,(buff+1)                            
                ld      h,a                                   
                ld      a,(buff)                              
                call    read_blk                                  
                ld      a,(buff+3)                            
                or      a                                     
                jp      z,exit                            
                ld      h,a                                   
                ld      a,(buff+2)                            
                call    read_blk                                                                  
exit:           ld de,0c000h      ; now we've loaded all the bits
                ld hl,2000h       ; copy them into the top of memory
                ld bc,3b00h       ; (where they should be) & boot!
                ldir              ; 
                ld      sp,buff+4                             
                ret                                           
sys_init:       ret
read_blk:       sub     a,0a0h    ;load bits low in memory so as not to crash
                or      a         ; the o/s.
                ld      d,a                                   
                ld      e,0                                   
                ld      a,h                                   
                rla                                           
                ld      h,a                                   
l1:             ex      de,hl                                 
                ld      bc,0ff80h                             
                add     hl,bc                                 
                ex      de,hl                                 
                push    de                                    
                push    hl                                    
                call    set_DMA                                  
                call    read_sect                                  
                pop     hl                                    
                pop     de                                    
                dec     h                                     
                jp      nz,l1                             
                ret                                           
set_DMA:        ld      c,1ah                                 
                call    bdos                                  
                ret                                           
read_sect:      ld      c,14h                                 
                ld      de,fcb                               
                call    bdos                                  
                or      a                                     
                ld      de,read_err                    
                ret     z                                     
abort:          ld      c,9                                   
                call    bdos                                  
                jp      0                                   
signon:         db      0ah,0dh,0ah,0dh,'CP/M loader v1.0'
                db      0ah,0dh,'$'
no_ccp:         db      'No CPM3.SYS file on disc......aborting$'
read_err:       db      'Error reading CPM3.SYS file......aborting$'
fcb:            db      0,'CPM3    SYS'
                dw      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
buff:           db      0
          db      0,'CPM3    SYS'
         