                jp      begin

trks:           db      40   ; tracks
secptr:         db      10   ; sectors per track
secpcy:		db	10   ; sectors per cylinder
sides:          db      0   ; double sided flag nz=double sided
drivemask:      db      0   ; port 23h drive select mask
drive:          db      0   ; mcal drive number. drivemask = 2^drive

sect:           db      0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19

masks:		db	1,2,4,8

begin:
		ld	c,9
		ld	de,signon
		call	5
		ld	a,(5fh)
		cp	'S'
		jr	nz,again
		ld	c,9		; read system tracks
		ld	de,source
		call	5
		ld	c,1
		call	5
		ld	a,0
		ld	hl,buff1
		ld	de,buff1+10*512-1
		ld	bc,0
		rst	8
		defb	0a4h
		and	7fh
		ld	de,errormess
		or	a
		jp	nz,emess
		ld	a,0
		ld	hl,buff2
		ld	de,buff2+10*512-1
		ld	bc,1
		rst	8
		defb	0a4h
		and	7fh
		ld	de,errormess
		or	a
		jp	nz,emess

again:          ld      a,(5ch)     ; fetch drive
                or      a
                ld      de,usage
                jp      z,emess
                cp      5
                ld      de,usage
                jp      nc,emess
                dec	a
		ld	(drive),a
		ld	hl,masks
		ld	c,a
		ld	b,0
		add	hl,bc
		ld	a,(hl)
		ld	(drivemask),a
		ld	a,(5dh)
		cp	'4'
		jr	z,fourty
		cp	'8'
		jr	z,eighty
		ld	de,usage
		jp	emess
eighty:		ld	a,80
		ld	(trks),a
fourty:		ld	a,(5eh)
		cp	'D'
		jr	z,double
		cp	'S'
		jr	z,single
		ld	de,usage
		jp	emess
double:		ld	a,0ffh
		ld	(sides),a
		ld	a,20
		ld	(secpcy),a

single:         ld      c,9
                ld      de,place
                call    5
                ld      c,1
                call    5
                cp      'E'
                ret     nz
                ld      c,9
                ld      de,crlf
                call    5

                ld      a,(drivemask)
                out     (23h),a
                ld      a,0
                rst     8h
                defb    0aeh
                call    z,cover                    ; z set if comm finished
                call    z,delay                    ; wait around a bit
                jr      nz,ferror


format:         ld      e,0
                jr      start
nxttrk:         ld      a,e                        ; step a track
                out     (1bh),a
                ld      a,10h
                rst     8h
                defb    0aeh
                call    z,cover                    ; z set if comm finished
                call    z,delay                    ; wait around a bit
                jr      nz,ferror
                in      a,(18h)
                and     0f9h
                cp      0a0h
                jp      nz,scode
start:          ld      ix,sect
                ld      a,(drivemask)
                out     (23h),a
                call    ftrk
                ld      a,(sides)
                or      a
                jr      z,skip1
                ld      a,(drivemask)
                set     4,a
                out     (23h),a
                call    ftrk
skip1:          push    de
                ld      c,2
                ld      e,'f'
                call    5
                pop     de
                inc     e
                ld      a,(trks)
                cp      e
                jp      nz,nxttrk
                jp      verify

scode:          ld      (0fb56h),a
                ld      a,0d0h
                out     (18h),a
ferror:         ld      de,errormess
                ld      c,9
                call    5
                rst     8h
                defb    0bdh
                jp      0

ftrk:           ld      hl,scode
                push    hl
                di
                ld      a,0f4h
                rst     8h
                defb    0aeh
floop:          in      a,(18h)       ; wait for commnad to start
                rrca                  ;   needed if head at trk0 when program
                jr      nc,floop      ;   started

                ld      hl,204eh
                call    fwrt
                ld      a,(secptr)
                ld      b,a
nextsect:       ld      hl,0c00h
                call    fwrt
                ld      hl,3f5h
                call    fwrt
                ld      hl,1feh
                call    fwrt
                ld      h,1
                ld      l,e
                call    fwrt
                ld      hl,101h
                call    fwrt
                ld      h,1
                ld      l,(ix+0)
                inc     ix
                call    fwrt
                ld      hl,102h
                call    fwrt
                ld      hl,1f7h
                call    fwrt
                ld      hl,164eh
                call    fwrt
                ld      hl,0c00h
                call    fwrt
                ld      hl,3f5h
                call    fwrt
                ld      hl,1fbh
                call    fwrt
                ld      hl,0e5h
                call    fwrt
                ld      hl,0e5h
                call    fwrt
                ld      hl,1f7h
                call    fwrt
                ld      hl,2c4eh
                call    fwrt
                djnz    nextsect
                ld      hl,eform
                ex      (sp),hl
tillend:        ld      hl,04eh
                call    fwrt
                jr      tillend
eform:          ld      a,0d0h
                out     (18h),a
                ei
                ret

fwrt:           in      a,(18h)
                rrca
                jr      nc,abort
                rrca
                jr      nc,fwrt
                ld      a,l
                out     (1bh),a
                dec     h
                jp      nz,fwrt
                ret
abort:          pop     hl
                ret

cover:          push    bc
                push    de
                ld      de,000
                ld      b,4
loop:           in      a,(18h)
                rrca
                jr      c,busy
                pop     de
                pop     bc
                xor     a
                ret
busy:           dec     de
                ld      a,d
                or      e
                jr      nz,loop
                djnz    loop
                pop     de
                pop     bc
                xor     a
                inc     a
                ret

delay:          push    de
                ld      de,1100h
loop1:          dec     de
                ld      a,d
                or      e
                jr      nz,loop1
                pop     de
                ret

verify:         ld      c,9
                ld      de,crlf
                call    5
		ld	a,(drive)
		ld	(0fb50h),a
		ld	a,0
		ld	(0fb51h),a
		ld	(0fb52h),a
		ld	hl,buffer
		ld	(0fb53h),hl
nextrk:         rst	8
		defb	0a2h
		and	7fh
		or	a
		jp	nz,err1
;               ld      bc,512		; removed as takes too long
;               ld      hl,buffer
;               ld      a,0e5h
;loopv:          cpi
;                jr      nz,err1
;                jp      po,ok
;                jp      loopv
ok:             ld	a,(secpcy)
		ld	b,a
		ld	a,(0fb52h)
		inc	a
		ld	(0fb52h),a
		cp	b
		jr	nz,nextrk
		ld	e,'v'
nextprn:	ld	c,2
		call	5
		ld	a,0
		ld	(0fb52h),a
		ld	a,(trks)
		ld	b,a
		ld	a,(0fb51h)
		inc	a
		ld	(0fb51h),a
		cp	b
		jr	nz,nextrk

                ld      de,crlf
		ld	c,9
		call	5

		ld	a,(5fh)
		cp	'S'
		jr	nz,repeat
		ld	a,(drive)			; write system tracks
		ld	hl,buff1
		ld	de,buff1+10*512-1
		ld	bc,0
		rst	8
		defb	0a5h
		and	7fh
		ld	de,errormess
		or	a
		jr	nz,emess
		ld	a,(drive)
		ld	hl,buff2
		ld	de,buff2+10*512-1
		ld	bc,1
		rst	8
		defb	0a5h
		and	7fh
		ld	de,errormess
		or	a
		jr	nz,emess
		ld	de,aok
		ld	c,9
		call	5

repeat:		ld	c,9
		ld	de,repmess
		call	5
		ld	c,1
		call	5
		cp	'Y'
		jp	z,again
		cp	'y'
		jp	z,again
		jp	0

emess:          ld      c,9
                call    5
                jp      0
err1:           ld      e,'.'
                jp      nextprn

errormess:      db      'error in formating.....aborting',0ah,0dh,'$'

signon:         db      'Albert format v2.1 ',0ah,0dh,'$'
place:          db      0dh,0ah,'Insert disk to be formatted and press E',0ah,0dh,'$'

usage:          db      'Usage: eform drive:tracks_sides_system',0ah,0dh

crlf:           db      0ah,0dh,'$'

source:		db 	'Insert disc with system tracks in A:',0dh,0ah
		db 	'and press any key to continue',0ah,0dh,'$'

aok:		db 	'System tracks copied.',0ah,0dh,'$'
repmess:	db	'Format another disc (Y/N):','$'

buff1:		ds 	10*512
buff2:		ds 	10*512

buffer          =       $
